#include <iostream>
#include <windows.h>
#include <vector>
#include <fstream>
#include <thread>

int runTest(std::string path, unsigned short numThreads=4, int prior=NORMAL_PRIORITY_CLASS) {
    DWORD startTime = GetTickCount();
    std::vector<HANDLE> processes;
    std::ifstream file(path);
    unsigned int digit_count = 0;
    char current_char;
    while (file.get(current_char)) {
        if (current_char == '\n')break;
        if (std::isdigit(current_char)) {
            ++digit_count;
            if (file.get(current_char)){
                if (std::isdigit(current_char))continue; else file.unget();
            }
        }
    }
    if (digit_count<numThreads){std::cerr<<"Requested test with "<<numThreads<<" threads, but matrix got only "<<digit_count<<" rows! Testing with "<<digit_count<<" threads."<<std::endl;numThreads=digit_count;}
    unsigned int step=digit_count/numThreads;
    for (int i = 0; i < numThreads-1; ++i) {
        STARTUPINFO si = { sizeof(si) };
        PROCESS_INFORMATION pi;
        std::string cmdline = "worker.exe " + path + ' ' + std::to_string(i*step) + ' ' + std::to_string(step);
#ifdef DEBUG
        if (
            #endif
            CreateProcess(
                NULL,                              // використовуємо модуль цього ж процесу
                const_cast<char*>(cmdline.c_str()),
                NULL,                              // атрибути процесу
                NULL,                              // атрибути потоку
                FALSE,                             // не успадковувати дескриптори
                prior,
                NULL,                              // змінна середовища
                NULL,                              // робоча директорія
                &si,                               // інформація про запуск
                &pi                                // інформація про процес
                )
            #ifdef DEBUG
            ) {
#else
            ;
#endif
            // Зберігаємо дескриптор процесу
            processes.push_back(pi.hProcess);
            CloseHandle(pi.hThread); // закриваємо дескриптор потоку
#ifdef DEBUG
    } else std::cerr << "Failed to create process: " << GetLastError() << std::endl;
#endif
    }
    std::string cmdline = "worker.exe " + path + ' ' + std::to_string((numThreads-1)*step) + ' ' + std::to_string(digit_count-step*(numThreads-1));
STARTUPINFO si = { sizeof(si) };
    PROCESS_INFORMATION pi;
#ifdef DEBUG
    if (
#endif
CreateProcess(
            NULL,                              // використовуємо модуль цього ж процесу
            const_cast<char*>(cmdline.c_str()),// командна строка
            NULL,                              // атрибути процесу
            NULL,                              // атрибути потоку
            FALSE,                             // не успадковувати дескриптори
            prior,
            NULL,                              // змінна середовища
            NULL,                              // робоча директорія
            &si,                               // інформація про запуск
            &pi                                // інформація про процес
            )
#ifdef DEBUG
    ) {
#else
    ;
#endif
        // Зберігаємо дескриптор процесу
        processes.push_back(pi.hProcess);
        CloseHandle(pi.hThread); // закриваємо дескриптор потоку
#ifdef DEBUG
    } else std::cerr << "Failed to create process: " << GetLastError() << std::endl;
#endif
    WaitForMultipleObjects(processes.size(), processes.data(), TRUE, INFINITE);
    
    // Закриваємо дескриптори процесів
    for (HANDLE hProcess : processes) {
        CloseHandle(hProcess);
    }
    
    return GetTickCount() - startTime;
}


inline bool exists(const std::string& name) {
    DWORD fileAttributes = GetFileAttributes(name.c_str());
    return (fileAttributes != INVALID_FILE_ATTRIBUTES && !(fileAttributes & FILE_ATTRIBUTE_DIRECTORY));
}
void ExtendConsoleWidth(unsigned short width) {
    HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
    CONSOLE_SCREEN_BUFFER_INFO csbi;
    GetConsoleScreenBufferInfo(hConsole, &csbi);
    if (csbi.dwSize.X>=width)return;
    COORD bufferSize;
    bufferSize.X = width;
    bufferSize.Y = csbi.dwSize.Y;
    SetConsoleScreenBufferSize(hConsole, bufferSize);
    SMALL_RECT windowSize = csbi.srWindow;
    windowSize.Right = windowSize.Left + width - 1;
    SetConsoleWindowInfo(hConsole, TRUE, &windowSize);
}

int main() {
    ExtendConsoleWidth(86);
    std::cout << "--Welcome to os/lab3/os3!--" << std::endl << std::endl;

    std::string filename = "matrix.txt";

    if (!exists(filename)) {
        std::cout << "matrix.txt not found";
        if (exists("genmatrix.exe")) std::cout<<", hovewer it can be generated."<<std::endl<<"1. Generate!"<<std::endl<<"2. Input name"<<std::endl<<"0. Exit"<<std::endl;
        std::cin >> filename;
        while (!exists(filename)){
            if (filename=="1"){
                // std::string N;
                // std::string M;
                // std::cout<<"N? ";
                // std::cin>>N;
                // std::cout<<"M? ";
                // std::cin>>N;
                STARTUPINFO si = { sizeof(si) };
                PROCESS_INFORMATION pi;
            CreateProcess("genmatrix.exe",NULL/*const_cast<char*>(("genmatrix.exe"+N+" "+M).c_str())*/,NULL,NULL,0,0,NULL,NULL,&si,&pi);
            WaitForSingleObject(pi.hProcess, INFINITE);
            filename="matrix.txt";}
            else if (filename=="0")return 0;else if (filename=="2")continue;else {std::cout<<"Wrong input."<<std::endl;std::cin>>filename;}}getchar();
    } else std::cout << "File matrix.txt found." << std::endl;

    int prior = NORMAL_PRIORITY_CLASS; // Default value for A

    char choice;
    while (true) {
        std::cout << "1. Run tests" << std::endl;
        std::cout << "2. Set priority" << std::endl;
        std::cout << "0. Exit" << std::endl;
        choice = std::getchar();
        if (choice == '1') {
            for (int i = 1; i <= std::thread::hardware_concurrency()*2; ++i) {
                std::cout << i << " thread";
                if (i-1) std::cout << 's';
                std::cout << " took " << runTest(filename, i, prior) << "ms" << std::endl;
            }break;
        } else if (choice == '2') {
            std::cout << "Enter new value for priority:" << std::endl;
            std::cout << "  64 for IDLE_PRIORITY_CLASS" << std::endl;
            std::cout << "  16384 for BELOW_NORMAL_PRIORITY_CLASS" << std::endl;
            std::cout << "  32 for NORMAL_PRIORITY_CLASS" << std::endl;
            std::cout << "  32768 for ABOVE_NORMAL_PRIORITY_CLASS" << std::endl;
            std::cout << "  128 for HIGH_PRIORITY_CLASS" << std::endl;
            std::cout << "  256 for REALTIME_PRIORITY_CLASS" << std::endl;
            std::cout << "Your choice: ";
            std::cin >> prior;
            std::cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n'); // Clear input buffer
        } else if (choice == '0')break;
        else std::cout << "Wrong input." << std::endl;
    }
    return 0;
}
